LLM agents is a python package that contains a collection of Language Model (LLM) agents specialized in different
domains involves
several key components. Each agent within the package would be tailored to its specific field, such as economics, energy
analysis, geopolitical analysis, and transportation supply chain analysis. Below is an elaboration on the skeleton
structure of such a software package:

![llm_agents_logo.png](images%2Fllm_agents_logo.png)

# Package Structure

## `/llm_agents` (Root Directory)
Contains all the components of the package.

### `/agents`
This directory contains the implementation of each LLM agent.

#### `/economist`
- `economist_agent.py`: Implementation of the LLM agent specialized in economics.

#### `/energy_analyst`
- `energy_analyst_agent.py`: Implementation of the LLM agent specialized in energy analysis.

#### `/geopolitical_analyst`
- `geopolitical_analyst_agent.py`: Implementation of the LLM agent specialized in geopolitical analysis.

#### `/transportation_supply_chain_analyst`
- `transportation_supply_chain_analyst_agent.py`: Implementation of the LLM agent specialized in transportation and supply chain analysis.
